﻿-- Author      : Joshua Slaymaker - Slaymaker Studios
-- Create Date : 9/30/2008 10:28:53 PM
--Version 3.9
--11302

--*****************************************************************************************************************
--Must have 3 files inside the folder labeled the same name as the TOC name.  The TOC file/folder name is what the
--add shows up in the players addon listing.  Currently I have Frame.lua & Frame.xml & TargetingIcons_Classic.toc.
--Once I have these 3 files in the 1 folder named TargetingIcons_Classic then zip it for upload.
--*****************************************************************************************************************


--These are my global saved variables (Anything in the TOC file is saved after player logs out):
--*****************************************************************************************************************
names = nil;	--Defaulted to OFF before.  nil causes errors.  Defaulting to something else.
symbols = nil; --Defaulted to ON before.  nil causes errors.  Defaulting to something else.
namesPosX = -1;
namesPosY = -1;
namesWidth = -1;
namesHeight = -1;
symbolsPosX = -1;
symbolsPosY = -1;
symbolsWidth = -1;  --Needed for vert/horiz
symbolsHeight = -1;  --Needed for vert/horiz
symbolsIsHoriz = -1;  --Will be 1 or 0 for true or false.
mouseOver = nil;  --nil causes errors.  Defaulting to something else.
locked = nil;
skullChanges = nil;  --Normally liked this off but what if they player has to do reload ui a lot or dcs a lot. nil causes errors.  Defaulting to something else.
--*****************************************************************************************************************


--*****************************************************************************************************************
--This is the symbols bar loading of variables.  I probably should move some of these variables out to global space to use
--both with the namesframe as well as the symbols frame.
function SymbolsMain_OnLoad(self)
	--ChatFrame1:AddMessage("_OnLoad loaded");
	self:RegisterEvent("UNIT_TARGET"); --Is in classic api. This is used for the marking especially the skull.
	self:RegisterForDrag("LeftButton"); --Is NOT in classic api.  I'm not using this currently.
	--self:RegisterEvent("ADDON_LOADED");  --Is in classic api.  
	self:RegisterEvent("PLAYER_REGEN_DISABLED"); --Is in classic api
	self:RegisterEvent("PLAYER_REGEN_ENABLED");  --Is in classic api
	self:RegisterEvent("RAID_ROSTER_UPDATE");  --Is in classic api
	--self:RegisterEvent("PARTY_LEADER_CHANGED");  --Is in classic api.  I'm not using this because doesn't matter about party leader anymore.
	--self:RegisterEvent("UPDATE_INSTANCE_INFO");  --Is in classic api.  I'm not using this.

	raidTargetSymbol = nil;
	typeofUnit = nil;
	targetIsCharmed = nil;
	targetIsMCed = nil;
	targetIsDead = nil;  --true or false
	playerIsInCombat = nil;  --true or false
	hasCC = nil;
	isElite = nil;
	isPlayerRaidOfficer = nil;	 --1 or 0
	isPlayerPartyLeader = nil;	 --1 or 0

	--This list of local symbols will hold the symbols and assing a name to them.
	UnmarkedTarget = nil;
	Unmarked = nil;
	Star = nil;
	Circle = nil;
	Diamond = nil;
	Triangle = nil;
	Moon = nil;
	Square = nil;
	Cross = nil;
	Skull = nil;
	
		
	defaultSymbolsPosX = 250;
	defaultSymbolsPosY = -7;
	
	defaultNamesPosX = 450;
	defaultNamesPosY = -5;

	ConfigureSymbolsMain(self);

	print("TargetingIcons - Loaded.  Use /ti options for slash commands.");
	--print("To show/hide the symbols/names bar you must be out of combat.");
end
--*****************************************************************************************************************

--*****************************************************************************************************************
--This should setup the positioning/setup of the addon from the saved variables and should be called at ADDON_LOADED
--in the XML file after the other scripts load.
function ConfigureSymbolsMain(self)
	--ChatFrame1:AddMessage("ConfigureSymbolsMain called");

	if(symbols == nil) then
		symbols = "NOT SET";
	end
	if(mouseOver == nil) then
		mouseOver = -1;
	end
	if(skullChanges == nil) then
		skullChanges = "NOT SET";
	end
	if(locked == nil) then
		locked = 0;
	end

end
--*****************************************************************************************************************

--*****************************************************************************************************************
--This should setup the positioning/setup of the addon from the saved variables and should be called at ADDON_LOADED
--in the XML file after the other scripts load.
function ConfigureRaidNamesScrollFrame(self)
	--ChatFrame1:AddMessage("ConfigureRaidNamesScrollFrame called");
	
	if(names == nil) then
		names = "NOT SET";
	end

end
--*****************************************************************************************************************


--*****************************************************************************************************************
--These are where the function calls are for the slashcommands which call control the bulk of the function calls.
SLASH_TARGETINGICONS1 = "/ti";
local function targSlashCom(str, editbox)
	local faction, factionLocale = UnitFactionGroup("player")
	if str == "options" then
		print("/ti (skull on|off) (clnames) (prnames) (lock) (unlock) (symbols on|off) (names on|off) (vert) (horiz) (mouseover on|off) (reset pos)");
	end

	if str == "skull on" then
		print("Your hostile enemy targets will change to a skull.  '/ti skull off' to turn off");
		skullChanges = "ON";
	end

	if str == "skull off" then
		print("Your target will no longer change symbols automatically.  '/ti skull on' to turn on");
		skullChanges = "OFF";
	end

	if str == "clnames" then
		print("Symbols to names cleared.");
		UnmarkedTarget = nil;
		Unmarked = nil;
		Star = nil;
		Circle = nil;
		Diamond = nil;
		Triangle = nil;
		Moon = nil;
		Square = nil;
		Cross = nil;
		Skull = nil;
	end

	--Next section replacing "ORCISH" or "COMMON" for nil to see if fixs SendChatMessage problem.  Will be the nil imbeded in the if statement.
	--Changing RAID_WARNING TO RAID.
	--Commented out large portion of code:  Did not fix issue.
	if str == "prnames" then
			if Unmarked ~= nil then
				SendChatMessage((UnmarkedTarget.."  --  "..Unmarked.."  --  "..UnmarkedTarget), "RAID", nil);
			end
			if Star ~= nil then
				SendChatMessage(("{Star}  --  "..Star.."  --  {Star}"), "RAID", nil);
			end
			if Circle ~= nil then
				SendChatMessage(("{Circle}  --  "..Circle.."  --  {Circle}"), "RAID", nil);
			end
			if Diamond ~= nil then
				SendChatMessage(("{Diamond}  --  "..Diamond.."  --  {Diamond}"), "RAID", nil);
			end
			if Triangle ~= nil then
				SendChatMessage(("{Triangle}  --  "..Triangle.."  --  {Triangle}"), "RAID", nil);
			end
			if Moon ~= nil then
				SendChatMessage(("{Moon}  --  "..Moon.."  --  {Moon}"), "RAID", nil);
			end
			if Square ~= nil then
				SendChatMessage(("{Square}  --  "..Square.."  --  {Square}"), "RAID", nil);
			end
			if Cross ~= nil then
				SendChatMessage(("{Cross}  --  "..Cross.."  --  {Cross}"), "RAID", nil);
			end
			if Skull ~= nil then
				SendChatMessage(("{Skull}  --  "..Skull.."  --  {Skull}"), "RAID", nil);
			end
	end

	if str == "lock" then
		--Prevent frames from moving here.
		locked = 1;
		print("Frames locked");

		RaidNamesScrollFrame:SetMovable(0);
		SymbolsMain:SetMovable(0);	

		--These next 2 lines hide a the background of the frame that is draggable.
		RaidNamesScrollFrame:SetBackdrop({bgFile = "", 
                                            edgeFile = "", 
                                            tile = true, tileSize = 16, edgeSize = 16, 
                                            insets = { left = 4, right = 4, top = 4, bottom = 4 }})
		RaidNamesScrollFrame:SetBackdropColor(0, 0, 0, 0);
		
		--These next 2 lines hide a the background of the frame that is draggable.
		SymbolsMain:SetBackdrop({bgFile = "", 
                                            edgeFile = "", 
                                            tile = true, tileSize = 16, edgeSize = 16, 
                                            insets = { left = 4, right = 4, top = 4, bottom = 4 }})
		SymbolsMain:SetBackdropColor(0, 0, 0, 0);
	end

	if str == "unlock" then
		locked = 0;
		--Prevent frames from moving here.
		print("Frames unlocked");
		
		RaidNamesScrollFrame:SetMovable(1);
		SymbolsMain:SetMovable(1);

		--These next 2 lines show a the background of the frame that is draggable.
		RaidNamesScrollFrame:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", 
                                            edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
                                            tile = true, tileSize = 16, edgeSize = 16, 
                                            insets = { left = 4, right = 4, top = 4, bottom = 4 }})
		RaidNamesScrollFrame:SetBackdropColor(1, 1, 1, 1);

		--These next 2 lines show a the background of the frame that is draggable.
		SymbolsMain:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", 
                                            edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
                                            tile = true, tileSize = 16, edgeSize = 16, 
                                            insets = { left = 4, right = 4, top = 4, bottom = 4 }})
		SymbolsMain:SetBackdropColor(1, 1, 1, 1);
	end

	if str == "symbols on" then
		symbols = "ON";
		if playerIsInCombat ~= true then
			--numberOfMembers = GetNumRaidMembers();  --0 if not in a raid.  --This seems to be breaking classic.  Leaving commented out.
			--isPlayerRaidOfficer = IsRaidOfficer();  --1 or 0  --This seems to be breaking classic.  Leaving commented out.
			--isPlayerPartyLeader = IsPartyLeader();	 --1 or 0  --This seems to be breaking classic.  Leaving commented out.
			playerInParty = UnitInParty("player"); -- 1 or nil  --This works in classic.
			--numPartyMembers = GetNumPartyMembers();  --This seems to be breaking classic.  Leaving commented out.

			--if ((playerInParty == 1  and numPartyMembers >=1 and numPartyMembers <= 4 and numberOfMembers == 0) or isPlayerRaidOfficer == 1) then  --Don't need for classic?
				SymbolsMain:Show();
			--end
			print("The symbols bar will be shown.  You can drag it where you would like unless it is locked.");
		end
		if playerIsInCombat == true then
			print("You must wait for after combat to make this change");	
		end

		
	end

	if str == "symbols off" then
		symbols = "OFF";
		if playerIsInCombat ~= true then
			--if names == "ON" then
				--RaidNamesScrollFrame:Hide();
			--end
			SymbolsMain:Hide();
			print("The symbols bar will be hidden.");
		end

		if playerIsInCombat == true then
			print("You must wait for after combat to make this change");	
		end
	end

	if str == "names on" then
		names = "ON";
		if playerIsInCombat ~= true then
			--if names == "ON" then

			--numberOfMembers = GetNumRaidMembers();  --0 if not in a raid.  --This seems to be breaking classic.  Leaving commented out.
			--isPlayerRaidOfficer = IsRaidOfficer();  --1 or 0  --This seems to be breaking classic.  Leaving commented out.
			--isPlayerPartyLeader = IsPartyLeader();	 --1 or 0  --This seems to be breaking classic.  Leaving commented out.
			playerInParty = UnitInParty("player"); -- 1 or nil  --This works in classic.
			--numPartyMembers = GetNumPartyMembers();  --This seems to be breaking classic.  Leaving commented out.

			--if ((playerInParty == 1  and numPartyMembers >=1 and numPartyMembers <= 4 and numberOfMembers == 0) or isPlayerRaidOfficer == 1)then
				RaidNamesScrollFrame:Show();
			--end
			--end
			--SymbolsMain:Show()
			
			print("Names of party/raid members will be shown.  You can drag it where you would like unless it is locked.");
		end
		if playerIsInCombat == true then
			print("You must wait for after combat to make this change");
		end
	end

	if str == "names off" then
		names = "OFF";
		if playerIsInCombat ~= true then
			--if names == "ON" then
				RaidNamesScrollFrame:Hide();
			--end
			--SymbolsMain:Show();
			
			print("Names of party/raid members will be hidden.");
		end
		if playerIsInCombat == true then
			print("You must wait for after combat to make this change");	
		end
	end

	if str == "reset pos" then  --Reset pos seperates scrollbar from the list of player names in Classic.  Not attached to parent?
		--SetPoint("TOPLEFT", "UIParent", "TOPLEFT", 0, -16);
		RaidNamesScrollFrame:SetPoint("TOPLEFT", defaultNamesPosX, defaultNamesPosY);
		SymbolsMain:SetPoint("TOPLEFT", defaultSymbolsPosX , defaultSymbolsPosY);
		print("Reset to original position.");
	end

	if str == "horiz" then
		print("Horizontal enabled.");
		SetHorizontal();
	end

	if str == "vert" then
		print("Vertical enabled.");
		SetVertical();
	end

	if str == "mouseover on" then 
		print("Mouseover enabled.");
		mouseOver = 1;
	end

	if str == "mouseover off" then 
		print("Mouseover disabled.");
		mouseOver = 0;
	end
	
end
SlashCmdList["TARGETINGICONS"] = targSlashCom
--*****************************************************************************************************************


--*****************************************************************************************************************
function RaidNames_Template_OnLoad(self)
	--ChatFrame1:AddMessage("_OnLoad loaded");
	self:RegisterEvent("UNIT_TARGET");
	self:RegisterEvent("PLAYER_REGEN_DISABLED");
	self:RegisterEvent("PLAYER_REGEN_ENABLED");
	self:RegisterEvent("RAID_ROSTER_UPDATE");
	--self:RegisterEvent("ADDON_LOADED");  --Is in classic api.  
	--self:RegisterEvent("PARTY_LEADER_CHANGED");
	--self:RegisterForDrag("LeftButton");
	
	--This may be defaulting the text on the templates.  I can't remember what this does.
	self.name = getglobal(self:GetName().."_Names");
	
	--ChatFrame1:AddMessage("RaidNames_Template_OnLoad loaded successfully.");
	--playerIsInCombat = UnitAffectingCombat("player");
	
	--if names == "ON" then
		--RaidNamesScrollFrame:Hide();
		--RaidNamesScrollFrame:Show();
	--end
end
--*****************************************************************************************************************

--*****************************************************************************************************************
function RaidNamesScrollFrame_OnLoad(self)
	self:RegisterForDrag("LeftButton");
	--self:RegisterEvent("ADDON_LOADED");  --Is in classic api.  

	--ChatFrame1:AddMessage("RaidNames_Template_OnLoad loaded successfully.");

	ConfigureRaidNamesScrollFrame(self);

	playerIsInCombat = UnitAffectingCombat("player");
	
	if names == "ON" then
		RaidNamesScrollFrame:Hide();
		RaidNamesScrollFrame:Show();
	end
end
--*****************************************************************************************************************

--*****************************************************************************************************************
function RaidNames_Template_OnClick(self, button, down, unit)
	--This whispers the unit the player clicks on, their symbol.
	local unit = self:GetAttribute("unit");
	local faction, factionLocale = UnitFactionGroup(unit);


	if UnitName("target") ~= nil then
		_raidIcon = GetRaidTargetIndex("target");
		_raidIconText = "Unmarked - "..UnitName("target");
		UnmarkedTarget = UnitName("target");
		Unmarked = UnitName(unit);
	end

	if _raidIcon == 0 then
		_raidIconText = "Unmarked - "..UnitName("target");
		UnmarkedTarget = UnitName("target");
		Unmarked = UnitName(unit);
	end
	if _raidIcon == 1 then
		_raidIconText = "{Star}";
		Star = UnitName(unit);
	end
	if _raidIcon == 2 then
		_raidIconText = "{Circle}";
		Circle = UnitName(unit);
	end
	if _raidIcon == 3 then
		_raidIconText = "{Diamond}";
		Diamond = UnitName(unit);
	end
	if _raidIcon == 4 then
		_raidIconText = "{Triangle}";
		Triangle = UnitName(unit);
	end
	if _raidIcon == 5 then
		_raidIconText = "{Moon}";
		Moon = UnitName(unit);
	end
	if _raidIcon == 6 then
		_raidIconText = "{Square}";
		Square = UnitName(unit);
	end
	if _raidIcon == 7 then
		_raidIconText = "{Cross}";
		Cross = UnitName(unit);
	end
	if _raidIcon == 8 then
		_raidIconText = "{Skull}";
		Skull = UnitName(unit);
	end


	--Next section replacing "ORCISH" or "COMMON" for nil to see if fixs SendChatMessage problem.  Will be the nil imbeded in the if statement.
	if UnitName("target") == nil then
		print("You do not have a target.");
	elseif UnitName("target") ~= nil then
		SendChatMessage(("Use your cc on ...".._raidIconText), "WHISPER", nil, UnitName(unit));
	end
end
--*****************************************************************************************************************

--*****************************************************************************************************************
function RaidNames_Template_OnShow(self)
	
	--Trying to add this line here to see if it stops defaulting to Names when it 1st loads.
	--self.name = getglobal(self:GetName().."_Names")
	--This line in a different spot may be causing the issue.  But if I don't initialize it shouldn't show it.
	
	local unit = self:GetAttribute("unit")
	if unit then
		self.name:SetText(UnitName(unit))
		local class = select(2, UnitClass(unit))
		local color = RAID_CLASS_COLORS[class] or "WARRIOR"
		self:SetBackdropColor(color.r, color.g, color.b)
		--ChatFrame1:AddMessage("Name of unit is "..UnitName(unit))
	end
	--numberOfMembers = GetNumRaidMembers()
	--ChatFrame1:AddMessage("Number of raid members:  "..numberOfMembers)
	--0 - None, 1 - Star, 2 - Circle, 3 - Diamond, 4 - Triangle, 5 - Moon, 6 - Square, 7 - Cross, 8 - Skull.
	--symbolOnTarget = GetRaidTargetIndex("target")
	--ChatFrame1:AddMessage(symbolOnTarget)

end
--*****************************************************************************************************************


--*****************************************************************************************************************
--This is if the icons are clicked to actually mark the currently selected target with SetRaidTarget.
function Button_OnClick(self, event, button)
	--ChatFrame1:AddMessage("A button was clicked.");
	local buttonClicked = self:GetName();
	--ChatFrame1:AddMessage(buttonClicked.." was clicked");

	if (buttonClicked == "buttonNull") then
		--ChatFrame1:AddMessage("Null Button pressed");
		SetRaidTarget("target", 0);
	end
	if (buttonClicked == "buttonStar") then
		SetRaidTarget("target", 1);
	end
	if (buttonClicked == "buttonCircle") then
		SetRaidTarget("target", 2);
	end
	if (buttonClicked == "buttonDiamond") then
		SetRaidTarget("target", 3);
	end
	if (buttonClicked == "buttonTriangle") then
		SetRaidTarget("target", 4);
	end
	if (buttonClicked == "buttonMoon") then
		SetRaidTarget("target", 5);
	end
	if (buttonClicked == "buttonSquare") then
		SetRaidTarget("target", 6);
	end
	if (buttonClicked == "buttonCross") then
		SetRaidTarget("target", 7);
	end
	if (buttonClicked == "buttonSkull") then
		SetRaidTarget("target", 8);
	end
end
--*****************************************************************************************************************


--*****************************************************************************************************************
--This will change the icons for the marking to be vertical rather than horizontal.
function SetVertical(self)
	--ChatFrame1:AddMessage("SetVertical called");
	buttonStar:SetPoint("TOPLEFT", "buttonNull", "TOPLEFT", 0, -16);
	buttonCircle:SetPoint("TOPLEFT", "buttonStar", "TOPLEFT", 0, -16);
	buttonDiamond:SetPoint("TOPLEFT", "buttonCircle", "TOPLEFT", 0, -16);
	buttonTriangle:SetPoint("TOPLEFT", "buttonDiamond", "TOPLEFT", 0, -16);
	buttonMoon:SetPoint("TOPLEFT", "buttonTriangle", "TOPLEFT", 0, -16);
	buttonSquare:SetPoint("TOPLEFT", "buttonMoon", "TOPLEFT", 0, -16);
	buttonCross:SetPoint("TOPLEFT", "buttonSquare", "TOPLEFT", 0, -16);
	buttonSkull:SetPoint("TOPLEFT", "buttonCross", "TOPLEFT", 0, -16);
	symbolsIsHoriz = 0;
	SymbolsMain:SetWidth(30);
	SymbolsMain:SetHeight(175);
end

--This will set the icons to be horizontal rather than vertical.
function SetHorizontal(self)
	--ChatFrame1:AddMessage("SetHorizontal called");
	buttonStar:SetPoint("TOPLEFT", "buttonNull", "TOPLEFT", 16, 0);
	buttonCircle:SetPoint("TOPLEFT", "buttonStar", "TOPLEFT", 16, 0);
	buttonDiamond:SetPoint("TOPLEFT", "buttonCircle", "TOPLEFT", 16, 0);
	buttonTriangle:SetPoint("TOPLEFT", "buttonDiamond", "TOPLEFT", 16, 0);
	buttonMoon:SetPoint("TOPLEFT", "buttonTriangle", "TOPLEFT", 16, 0);
	buttonSquare:SetPoint("TOPLEFT", "buttonMoon", "TOPLEFT", 16, 0);
	buttonCross:SetPoint("TOPLEFT", "buttonSquare", "TOPLEFT", 16, 0);
	buttonSkull:SetPoint("TOPLEFT", "buttonCross", "TOPLEFT", 16, 0);
	symbolsIsHoriz = 1;
	SymbolsMain:SetWidth(175);
	SymbolsMain:SetHeight(30);
end
--*****************************************************************************************************************

--*****************************************************************************************************************
--This function is for the alpha levels to change the frame to show itself on mouseover if the player has that
--turned on.  Every frame & button calls this and passes in either the RaidNamesScrollFrame or SymbolsMain to 
--show/hide them.
function Frame_OnEnter(self, frame)
	--frame:SetAlpha(1);
	if(mouseOver == 1) then
		if (MouseIsOver(frame)) then
   			--ChatFrame1:AddMessage("OnEnter:  Mouse is over frame");
			frame:SetAlpha(1);
		else
			frame:SetAlpha(0);
		end
	else
		frame:SetAlpha(1);
	end
end
--*****************************************************************************************************************

--*****************************************************************************************************************
--This function is for the alpha levels to change the frame to hide itself on mouseover leaving the frame if the 
--player has that turned on.  Every frame & button calls this and passes in either the RaidNamesScrollFrame or 
--SymbolsMain to show/hide them.

--I believe I should save the global variables positioning here based on what frame is going in to save the global
--variables for loading and repositioning when the player logs off.
function Frame_OnExit(self, frame)
	if(mouseOver == 1) then
		if (MouseIsOver(frame)) then
   			--ChatFrame1:AddMessage("OnEnter:  Mouse is over frame");
			frame:SetAlpha(1);
		else
			frame:SetAlpha(0);
		end	
	end

	
	--Trying to save the positioning of the frames on exit of the frame to the global.  Happens when they mouse exit.
	--Saves positioning based off which frame they are hovering over.
	--I could probably save the frame in TOC directly but don't want to leave anything to chance.
	--Making sure I can reconfigure my frames after reloading them from these values.
	local frameName = frame:GetName();
	--ChatFrame1:AddMessage(frameName);

	if(frameName == "SymbolsMain") then
		--ChatFrame1:AddMessage("Exit SymbolsMain");
		symbolsPosX = frame:GetLeft();
		symbolsPosY = frame:GetTop();
		symbolsWidth = frame:GetWidth();
		symbolsHeight = frame:GetHeight();
	end
	if(frameName == "RaidNamesScrollFrame") then
		--ChatFrame1:AddMessage("Exit RaidNamesScrollFrame");
		namesPosX = frame:GetLeft();
		namesPosY = frame:GetTop();
		namesWidth = frame:GetWidth();
		namesHeight = frame:GetHeight();
	end
end
--*****************************************************************************************************************

--*****************************************************************************************************************
--This is where the automarking comes in for marking the skull on your primary target if you are in combat.
--So if you tab to a different target the skull will follow who you are targeting.
--It uses SetRaidTarget("target", 8); for this based off certain conditions.
function TankTargetSymbols_OnEvent(event, frame)
	--ChatFrame1:AddMessage("TargetTargetSymbols_OnEvent called.")
	--I will want to have symbols set up for each class, skull will be main tank target.
	--cross will be offtank target.  Circle-A poly/sleep, Diamond-Banish/trap, Triangle-Sap/Trap
	--Moon-A poly/sleep, Square-Trap/sap/poly, Star-Shackle/trap
	--Will want to setup a bar for symbols for leaders & bar for characters(names) that can CC.
	--Want to have leader set up generic targets and if targeting a symboled target and clicks on
	--CC name it will whisper them.  When done testing, make only work on elites.
	faction, factionLocale = UnitFactionGroup("player")
	isTargetEnemy = UnitIsEnemy("target", "player")  --true or false
	playerInParty = UnitInParty("player") -- 1 or nil
	--isPlayerRaidOfficer = IsRaidOfficer()  --1 or 0  --This seems to be breaking classic.  Leaving commented out.
	--isPlayerPartyLeader = IsPartyLeader()	 --1 or 0  --This seems to be breaking classic.  Leaving commented out.
	--numPartyMembers = GetNumPartyMembers()  --This seems to be breaking classic.  Leaving commented out.
	--numRaidMembers = GetNumRaidMembers()  --This seems to be breaking classic.  Leaving commented out.
	--typeofUnit = UnitRace("target")--Undead, nightelf...This will help to get the symbols based on

	targetIsCharmed = UnitIsCharmed("target")  --1 returns as true, MC is a type of charm.

	--targetIsMCed = UnitIsPossessed("target") --1 means target is Mind controlled.
	--Might need to use UnitDebuff to get information about a units debuffs to see if the
	--target is poly'd, shacked, or dotted...

	targetIsDead = UnitIsDead("target")  --Maybe used to take the skull off the dead target.
	--local targetIsElite =

	playerIsInCombat = UnitAffectingCombat("player")  --true means player is in combat.
	--Returns "elite", "normal", "rare", "rareelite", "worldboss"  Turn on when done testing.
	--isElite = UnitClassification("target")  Turn on when done testing.

	--So far changes targets correctly, not need to get it to not change if the target has a cc on them.
	 --1 will mean the target has a CC.  I will need to look up all class CC to get exact spell debuff names.



	--if event=="UNIT_AURA" and isTargetEnemy then
		--ChatFrame1:AddMessage("Buffs changed")
		--local index = 1
		--local name, rank, icon, debuffStack, debuffType, duration, timeLeft
		--local tempName, tempIndex  --These will hold a temporary debuff to pay attention to the index/names
		--of a particular ability like a fear debuff and it's debuff index.

		--This section looks for a certain debuff(the cc) and will process the symbol if it's still on it.
		--name, rank, icon, debuffStack, debuffType, duration, timeLeft = UnitDebuff("target", index)
		--index=index+1
		--if name=="Fear" then  --This test must be the exact same as in the while loop.
			--tempName = name
			--tempIndex = index
			--SetRaidTarget("target", 3)
			--ChatFrame1:AddMessage("Target has been feared.")
		--end
		--while name do
			--name, rank, icon, debuffStack, debuffType, duration, timeLeft = UnitDebuff("target", index)  --This will take the debuff off the target.
			--if name=="Fear" then  --Just testing it, have it test name to the types of cc and change hasCC to 1 if found.
				--SetRaidTarget("target", 3)
				--ChatFrame1:AddMessage("Target has been feared.")
			--end

			--index=index+1
		--end
	--end


	--Commenting this block out due to breaking classic?  --Player regen works.  unit target works.  Just not sure about raid roster update.
	--Will need to test add with raid leader changes.  Found out that bool is read as 0 or 1 for most of things in classic which brok a lot.
	if event =="PLAYER_REGEN_ENABLED" or event == "PLAYER_REGEN_DISABLED" or event == "UNIT_TARGET" or event == "RAID_ROSTER_UPDATE" then
		playerIsInCombat = UnitAffectingCombat("player")  --true or false
		--playerInParty = UnitInParty("player") -- 1 or nil  --This seems to be ok for classic.
		--isPlayerRaidOfficer = IsRaidOfficer()  --1 or 0  --This seems to be breaking classic.  Leaving commented out.
		--isPlayerPartyLeader = IsPartyLeader()	 --1 or 0  --This seems to be breaking classic.  Leaving commented out.
		--numPartyMembers = GetNumPartyMembers()  --This seems to be breaking classic.  Leaving commented out.
		--numRaidMembers = GetNumRaidMembers()  --This seems to be breaking classic.  Leaving commented out.
		--if event == "RAID_ROSTER_UPDATE" then
			--ChatFrame1:AddMessage("Number of party members:  "..numPartyMembers)
		--end

		--if playerIsInCombat ~= true then
			--if ((playerInParty == 1  and numPartyMembers >=1 and numPartyMembers <= 4 and numRaidMembers == 0) or isPlayerRaidOfficer == 1) and names == "ON" then
				--ChatFrame1:AddMessage("RaidNamesScrollFrame should now be shown.")
			--	RaidNamesScrollFrame:Show()
			--else
			--	if ((playerInParty == 1  and numPartyMembers >=1 and numPartyMembers <= 4 and numRaidMembers == 0) or isPlayerRaidOfficer == 1) and names == "ON" then
			--		RaidNamesScrollFrame:Show()
			--	end
			--	RaidNamesScrollFrame:Hide()
			--end
			--if ((playerInParty == 1  and numPartyMembers >=1 and numPartyMembers <= 4 and numRaidMembers == 0) or isPlayerRaidOfficer == 1) and symbols == "ON" then
				--ChatFrame1:AddMessage("SymbolsMain should now be shown.")
			--	SymbolsMain:Show()
			--else
			--	if ((playerInParty == 1  and numPartyMembers >=1 and numPartyMembers <= 4 and numRaidMembers == 0) or isPlayerRaidOfficer == 1) and symbols == "ON" then
			--		SymbolsMain:Show()
			--	end
			--	SymbolsMain:Hide()
			--end
		--end
	end

	if event=="UNIT_TARGET" then
	--print("UNIT_TARGET event triggered.")
	--if event=="UNIT_TARGET" and isTargetEnemy==true and targetIsCharmed~=1 and targetIsMCed~=1 and hasCC ==nil then --and isElite=="elite" then  --Possibly not working due to classic?
		--ChatFrame1:AddMessage("Target changed - Enemy target targeted")  --Used to make sure event handled correctly.
		--1-Star, 2-Circle, 3-Diamond, 4-Triangle, 5-Moon, 6-Square, 7-Cross, 8-Skull
		raidTargetSymbol = GetRaidTargetIndex("target")  --Works for classic.
		isTargetEnemy = UnitIsEnemy("target", "player")
		
		--print(isTargetEnemy)  --Works in classic -Only red targets, not neutrals.
		--print(raidTargetSymbol)
		--print(playerIsInCombat)  -- Works in classic
		--print(skullChanges)  --Works in classic.
		--print(targetIsDead)  --Works in classic.
		
		--Removed if in combat.  Thinking may not be working because not in a party?
		if isTargetEnemy==true and raidTargetSymbol==nil and skullChanges=="ON" and playerIsInCombat==true then  --Possibly not working due to classic?
			--print("Should be setting to skull")
			--8 for Skull
			SetRaidTarget("target", 8);
		end

		if targetIsDead==true then  --Commenting to test classic.  Needs back on.
			--print("Should be removing skull")
			SetRaidTarget("target", 0);  --Should clear the skull off.
		end
	end
end
--*****************************************************************************************************************


